package com.maintain.business.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.maintain.business.domain.ErpVehicleModel;
import com.maintain.business.domain.vo.ErpVehicleModelVo;
import com.maintain.business.mapper.ErpVehicleModelMapper;
import com.maintain.common.excel.ExcelListener;
import com.maintain.common.excel.ExcelResult;
import com.maintain.common.exception.ServiceException;
import com.maintain.common.helper.LoginHelper;
import com.maintain.common.utils.ValidatorUtils;
import com.maintain.common.utils.spring.SpringUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 客户自定义导入
 *
 * @author liushuai
 */
@Slf4j
public class ErpVehicleModelImportListener extends AnalysisEventListener<ErpVehicleModelVo> implements ExcelListener<ErpVehicleModelVo> {

    private final ErpVehicleModelMapper vehicleModelMapper;

    private final Boolean isUpdateSupport;

    private final String operName;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ErpVehicleModelImportListener(Boolean isUpdateSupport) {
        this.vehicleModelMapper = SpringUtils.getBean(ErpVehicleModelMapper.class);
        this.isUpdateSupport = isUpdateSupport;
        this.operName = LoginHelper.getUsername();
    }

    @Override
    public void invoke(ErpVehicleModelVo vehicleModelImportVo, AnalysisContext context) {
        LambdaQueryWrapper<ErpVehicleModel> erpClientLambdaQueryWrapper = new LambdaQueryWrapper<>();
        erpClientLambdaQueryWrapper.eq(ErpVehicleModel::getCarTypeCode, vehicleModelImportVo.getCarTypeCode());
        ErpVehicleModel vehicleModel = this.vehicleModelMapper.selectOne(erpClientLambdaQueryWrapper);
        try {
            // 验证是否存在这个客户
            if (ObjectUtil.isNull(vehicleModel)) {
                vehicleModel = BeanUtil.toBean(vehicleModelImportVo, ErpVehicleModel.class);
                ValidatorUtils.validate(vehicleModel);
                vehicleModelMapper.insert(vehicleModel);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、车型编号 ").append(vehicleModel.getCarTypeCode()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long vehicleModelId = vehicleModel.getId();
                vehicleModel = BeanUtil.toBean(vehicleModelImportVo, ErpVehicleModel.class);
                vehicleModel.setId(vehicleModelId);
                ValidatorUtils.validate(vehicleModel);
                vehicleModelMapper.updateById(vehicleModel);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、车型编号 ").append(vehicleModel.getCarTypeCode()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、车型编号 ").append(vehicleModel.getCarTypeCode()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、车型编号 " + vehicleModel.getCarTypeCode() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ErpVehicleModelVo> getExcelResult() {
        return new ExcelResult<ErpVehicleModelVo>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ErpVehicleModelVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
